package com.loafle.overflow.crawler;

import org.snmp4j.Snmp;
import org.snmp4j.TransportMapping;
import org.snmp4j.smi.Address;
import org.snmp4j.transport.DefaultUdpTransportMapping;

import java.io.IOException;
import java.util.Map;

/**
 * Created by insanity on 17. 4. 10.
 */
public class Crawler {

    //v2c
    private static String addr = "192.168.1.215";
    private static String port = "161";
    private static String community = "public";

    /**
     * v3
     * loafle MD5 "qwer5795" DES "qweqwe123" : AUTHPRIV
     * loafle2 SHA "qwer5795" AES "qweqwe123" : AUTHPRIV
     * loafle3 MD5 "qwer5795" : AUTHNOPRIV
     * loafle4 :NOAUTHNOPRIV
     */
    private static String user = "loafle3";
    private static int authType = 1;
    private static String authPass = "qwer5795";
    private static int privType = 0;
    private static String privPass = "qweqwe123";

    public static void main(String[] args) {
        useV2c();
        useV3();
    }

    private static void useV2c() {
        Snmp snmp = null;
        TransportMapping<? extends Address> transport = null;
        try {
            transport = new DefaultUdpTransportMapping();
            snmp = new Snmp(transport);
            transport.listen();
            SNMPv2c snmpV2 = new SNMPv2c(snmp);

            Boolean isOk = snmpV2.validate(addr, port, community);
            System.out.println("validate: " + isOk);
            Map walkResult = snmpV2.walk(addr, port, community, "1.3.6.1.2.1.25.2.3.1.3");
            printResult(walkResult);
            Map getResult = snmpV2.get(addr, port, community, new String[]{"1.3.6.1.2.1.1.5.0", "1.3.6.1.2.1.2.2.1.6.2"});
            printResult(getResult);

        } catch (Exception e) {
            System.err.println("An Exception happend as follows.");
            System.err.println(e.getMessage());
            e.printStackTrace();
        } finally {
            if (snmp != null) {
                try {
                    snmp.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (transport != null) {
                try {
                    transport.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private static void useV3() {
        Snmp snmp = null;
        TransportMapping<? extends Address> transport = null;

        try {
            transport = new DefaultUdpTransportMapping();
            snmp = new Snmp(transport);
            transport.listen();
            SNMPv3 snmpV3 = new SNMPv3(snmp);

            Boolean isOk = snmpV3.validate(addr, port, user, authType, authPass, privType, privPass);
            System.out.println("validate: " + isOk);
            Map walkResult = snmpV3.walk(addr, port, user, authType, authPass, privType, privPass, "1.3.6.1.2.1.25.2.3.1.3");
            printResult(walkResult);
            Map getResult = snmpV3.get(addr, port, user, authType, authPass, privType, privPass, new String[]{"1.3.6.1.2.1.1.5.0", "1.3.6.1.2.1.2.2.1.6.2"});
            printResult(getResult);

        } catch (Exception e) {
            System.err.println("An Exception happend as follows.");
            System.err.println(e.getMessage());
            e.printStackTrace();
        } finally {
            if (snmp != null) {
                try {
                    snmp.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (transport != null) {
                try {
                    transport.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private static void printResult(Map<String, String> result) {

        for (Map.Entry<String, String> entry : result.entrySet()) {
            System.out.printf("oid: %s - value: %s\n", entry.getKey(), entry.getValue());
        }

    }

    public String add(String configPath) {
        return null;
    }
    public String init(String configPath) {
        return null;
    }
    public String get(String id) {
        return null;
    }
    public String remove(String id) {
        return null;
    }
}